<?php
/*
<mt:SearchObjectsByFields
    model="Book"
    datasource="customobject"
    status="2"
    debug="1">
    <mt:BookName>(<mt:BookID>)
</mt:SearchObjectsByFields>
?field.isbn=ABCDE
?field.isbn=ABCDE&field.email=LIKE%3D%25alfasado%25&and_or=or&include_blogs=all
?field.isbn=ABCDE&field.book_id=<%3D100
?field.isbn[]=ABCDE&field.isbn[]=LIKE%3D%25ABC%25&query=MT%20PowerCMS&query_and_or=or&query_column=name
*/
function smarty_block_mtsearchobjectsbyfields ( $args, $content, &$ctx, &$repeat ) {
    $localvars = array( array( 'object', 'total_result',
        '_objects_counter', 'objects', 'blog', 'blog_id' ), common_loop_vars() );
    if ( isset( $args[ 'datasource' ] ) ) {
        $datasource = $args[ 'datasource' ];
    }
    if (! isset( $content ) ) {
        ini_set( 'memory_limit', '256M' );
        $ctx->localize( $localvars );
        global $customfield_types;
        if ( isset( $_REQUEST[ 'include_blogs' ] ) && ( $_REQUEST[ 'include_blogs' ] ) ) {
            $args[ 'include_blogs' ] = $_REQUEST[ 'include_blogs' ];
        }
        if ( isset( $_REQUEST[ 'blog_ids' ] ) && ( $_REQUEST[ 'blog_ids' ] ) ) {
            $args[ 'blog_ids' ] = $_REQUEST[ 'blog_ids' ];
        }
        if ( isset( $_REQUEST[ 'include_with_website' ] ) && ( $_REQUEST[ 'include_with_website' ] ) ) {
            $args[ 'include_with_website' ] = $_REQUEST[ 'include_with_website' ];
        }
        if ( isset( $_REQUEST[ 'exclude_blogs' ] ) && ( $_REQUEST[ 'exclude_blogs' ] ) ) {
            $args[ 'exclude_blogs' ] = $_REQUEST[ 'exclude_blogs' ];
        }
        $include_exclude_blogs = $ctx->mt->db()->include_exclude_blogs( $args );
        if ( isset( $args[ 'query' ] ) ) {
            $query = $args[ 'query' ];
        }
        $query_params = array();
        foreach ( $_REQUEST as $key => $values ) {
            if ( preg_match( '/^field/', $key ) ) {
                $key = str_replace( '_', '.', $key );
                if ( is_string ( $values ) ) {
                    $values = array( $values );
                }
                foreach ( $values as $value ) {
                    $_op = '=';
                    if ( strpos( $value, '=' ) !== FALSE ) {
                        $p = explode( '=', $value );
                        $_op = strtoupper( $p[ 0 ] );
                        $_op = $ctx->mt->db()->escape( $_op );
                        $value = $p[ 1 ];
                    }
                    $value = $ctx->mt->db()->escape( $value );
                    if ( preg_match( '/[A-Z]/', $_op ) ) {
                        $_op = " ${_op} ";
                    }
                    $query_params[] = "${key}${_op}${value}";
                }
            }
        }
        if ( count( $query_params ) ) {
            $query = implode( '&', $query_params );
        }
        $blog = $ctx->stash( 'blog' );
        $blog_id = $blog->id;
        $qs = preg_split('/&/', $query );
        $kays = array();
        if ( isset( $args[ 'and_or' ] ) ) {
            $and_or = $args[ 'and_or' ];
        } else if ( isset( $_REQUEST[ 'and_or' ] ) && ( $_REQUEST[ 'and_or' ] ) ) {
            $and_or = $_REQUEST[ 'and_or' ];
        }
        if ( isset( $args[ 'debug' ] ) ) {
            $debug = $args[ 'debug' ];
        }
        if ( $and_or ) {
            $and_or = strtolower( $and_or );
            if ( ( $and_or != 'or' ) && ( $and_or != 'and' ) ) {
                $and_or = NULL;
            }
        }
        if ( isset( $args[ 'model' ] ) ) {
            $model = $args[ 'model' ];
            $class = strtolower( $model );
        }
        if ( isset( $args[ 'status' ] ) ) {
            $status = $args[ 'status' ];
        }
        if (! $datasource ) $datasource = 'entry';
        if (! $and_or ) $and_or = 'or';
        $params = array();
        foreach ( $qs as $q ) {
            if ( preg_match('/(^.*?)(\s*=\s*|\s*>\s*|\s*<\s*|\s*<=\s*|\s*>=\s*|\s*LIKE\s*|\s*NOT\sLIKE\s*)(.*$)/i', $q, $matchs ) ) {
                $key = $matchs[ 1 ];
                $key = strtolower( $key );
                $oparator = strtoupper( $matchs[ 2 ] );
                $value = $matchs[ 3 ];
                $key = $ctx->mt->db()->escape( $key );
                $value = $ctx->mt->db()->escape( $value );
                // $oparator = $ctx->mt->db()->escape( $oparator );
                $key = preg_replace( '/^field\./', '', $key );
                $keys[] = $key;
                $params[ $key ] = array( 
                                   'value' => $value,
                                   'operator' => $oparator );
            }
        }
        $fields;
        if ( $model ) {
            $model = $ctx->mt->db()->escape( $model );
            $model_lc = strtolower( $model );
        }
        $custom_fields = $ctx->stash( 'custom_fields' );
        if ( isset( $custom_fields ) ) {
            foreach ( $custom_fields as $cf ) {
                if ( $cf->field_obj_type == $model_lc ) {
                    $fields[] = $cf;
                }
            }
        }
        if (! isset( $fields ) ) {
            require_once( 'class.mt_field.php' );
            $field = new Field;
            if ( count( $keys ) > 1 ) {
                $where = implode( "' OR field_basename='", $keys );
                $where = " ( field_basename='" . $where . "' ) ";
            } else {
                $where = "field_basename='" . $key . "'";
            }
            $where .= " AND ( field_blog_id ${include_exclude_blogs} OR field_blog_id = 0 ) ";
            if ( $model ) {
                $where .= " AND field_obj_type='${model_lc}'";
            }
            if ( $debug ) {
                echo htmlspecialchars( $where );
                echo '<br />';
            }
            // Search CustomFields
            // field_basename='${field_basename}' AND ( field_blog_id = 1 OR field_blog_id = 0 ) AND field_obj_type='${model_lc}'
            $fields = $field->Find( $where, FALSE, FALSE, array() );
        }
        $match_fields = array();
        if ( $fields ) {
            foreach( $fields as $field ) {
                $field_type = $field->field_type;
                $basename = $field->field_basename;
                $match_fields[] = $basename;
                $params[ $basename ][ 'column_def' ] = $customfield_types[ $field_type ][ 'column_def' ];
            }
        } else {
            $ctx->restore( $localvars );
            $repeat = FALSE;
            return;
        }
        foreach ( $params as $key => $values ) {
            if (! in_array( $key, $match_fields ) ) {
                unset( $params[ $key ] );
            }
        }
        $cf_where = '';
        $i = 0;
        $col_names = array( $datasource . '_meta_' . $datasource . '_id',
        $datasource . '_meta_type' );
        foreach ( $params as $key => $values ) {
            if ( $values[ 'column_def' ] ) {
                $col = $datasource . '_meta_' . $values[ 'column_def' ];
                $op = $values[ 'operator' ];
                $value = $values[ 'value' ];
                if ( (! $op ) || (! $value ) ) {
                    continue;
                }
                if ( $i > 0 ) {
                    $cf_where .= ' OR ';
                }
                $cf_where .= "( ${col} ${op} '${value}' AND ${datasource}_meta_type='field.${key}' )";
                $col_names[] = $col;
                $i++;
            }
        }
        if ( $datasource == 'customobject' ) {
            $model = 'CustomObject';
        }
        $col_names = array_unique( $col_names );
        $col_names = implode( ',', $col_names );
        $sorted = FALSE;
        $limit_offset = TRUE;
        if ( $and_or == 'and' ) {
            $cf_sql = "SELECT ${col_names} FROM mt_${datasource}_meta WHERE ${cf_where}";
            if ( $debug ) {
                echo htmlspecialchars( $cf_sql );
                echo '<br />';
            }
            // Search mt_${datasource}_meta
            // SELECT * FROM mt_${datasource}_meta WHERE ${datasource}_blog_id = 1 AND ( ( ${datasource}_meta_vchar_idx = '${value}' AND customobject_meta_type='field.${field_basename}' ) )
            $match_fld = $ctx->mt->db()->Execute( $cf_sql );
            $match_cnt = $match_fld->RecordCount();
            if (! $match_cnt ) {
                $ctx->restore( $localvars );
                $repeat = FALSE;
                return;
            }
            $match_cnt--;
            $id_col = "${datasource}_meta_${datasource}_id";
            $type_col = "${datasource}_meta_type";
            $results = array();
            for ( $i = 0; $i <= $match_cnt; $i++ ) {
                $match_fld->Move( $i );
                $row = $match_fld->FetchRow();
                $id = $row[ $id_col ];
                $type = $row[ "${datasource}_meta_type" ];
                $type = preg_replace( '/^field\./', '', $type );
                $col = $params[ $type ][ 'column_def' ];
                $col = "${datasource}_meta_${col}";
                $value = $row[ $col ];
                $results[ $id ][ $type ] = $value;
            }
            require_once( 'class.sobf_custom_sort.php' );
            $custom_sort = new SearchObjectByFieldCustomSort;
            $obj_ids = $custom_sort->sort_and( $results, $params, $sorted, $limit_offset );
            // $obj_ids = $custom_sort->custom_sort( $results, $params, $sorted, $limit_offset );
            if (! count( $obj_ids ) ) {
                $repeat = FALSE;
                $ctx->restore( $localvars );
                return;
            }
            $ids = join( ',', $obj_ids );
        }
        require_once( 'class.mt_' . strtolower( $model ) . '.php' );
        $_obj = new $model;
        $extras = array();
        if (! $sorted ) {
            if ( isset( $args[ 'sort_by' ] ) && ( $args[ 'sort_by' ] ) ) {
                $sort_by = $args[ 'sort_by' ];
            } else if ( isset( $_REQUEST[ 'sort_by' ] ) && ( $_REQUEST[ 'sort_by' ] ) ) {
                $sort_by = $_REQUEST[ 'sort_by' ];
            }
            if ( $sort_by ) {
                $sort_by = $ctx->mt->db()->escape( $sort_by );
                if ( preg_match( '/^field/', $sort_by ) ) {
                    $sort_by = str_replace( '_', '.', $sort_by );
                    $sort_by = preg_replace( '/^field\./', '', $sort_by );
                    if ( $params[ $sort_by ] ) {
                        $sort_col = $params[ $sort_by ][ 'column_def' ];
                        if ( $sort_col ) {
                            $bulk_sort = 1;
                            if ( strpos( $sort_col, 'integer' ) !== FALSE ) {
                                $bulk_sort_type = 'integer';
                            } else if ( strpos( $sort_col, 'float' ) !== FALSE ) {
                                $bulk_sort_type = 'integer';
                            } else {
                                $bulk_sort_type = 'string';
                            }
                        }
                    } else {
                        $sort_by = NULL;
                    }
                }
                if ( $sort_by ) {
                    if ( isset( $args[ 'sort_order' ] ) && ( $args[ 'sort_order' ] ) ) {
                        $sort_order = $args[ 'sort_order' ];
                    } else if ( isset( $_REQUEST[ 'sort_order' ] ) && ( $_REQUEST[ 'sort_order' ] ) ) {
                        $sort_order = $_REQUEST[ 'sort_order' ];
                    }
                    if ( (! $sort_order ) || ( $sort_order == 'descend' ) ) {
                        $sort_order = 'DESC';
                    } else {
                        $sort_order = 'ASC';
                    }
                }
                if (! $bulk_sort ) {
                    $extras[ 'sort_order' ] = $sort_order;
                }
            }
        }
        if ( isset( $args[ 'offset' ] ) && ( $args[ 'offset' ] ) ) {
            $offset = $args[ 'offset' ] + 0;
            if ( (! $bulk_sort ) && ( $limit_offset ) ) {
                $extras[ 'offset' ] = $offset;
            }
        } else if ( isset( $_REQUEST[ 'offset' ] ) && ( $_REQUEST[ 'offset' ] ) ) {
            $offset = $_REQUEST[ 'offset' ] + 0;
            if ( (! $bulk_sort ) && ( $limit_offset ) ) {
                $extras[ 'offset' ] = $offset;
            }
        }
        if ( isset( $args[ 'limit' ] ) && ( $args[ 'limit' ] ) ) {
            $limit = $args[ 'limit' ] + 0;
            if ( (! $bulk_sort ) && ( $limit_offset ) ) {
                $extras[ 'limit' ] = $limit;
            }
        } else if ( isset( $_REQUEST[ 'limit' ] ) && ( $_REQUEST[ 'limit' ] ) ) {
            $limit = $_REQUEST[ 'limit' ] + 0;
            if ( (! $bulk_sort ) && ( $limit_offset ) ) {
                $extras[ 'limit' ] = $limit;
            }
        }
        if ( $limit ) {
            if ( isset( $offset ) ) {
                $offset = 0;
            }
        }
        $whereOrderBy = "${datasource}_blog_id $include_exclude_blogs";
        if ( $status ) {
            if ( $_obj->has_column( "${datasource}_status" ) ) {
                $status = $ctx->mt->db()->escape( $status );
                $whereOrderBy .= " AND ${datasource}_status=${status}";
            }
        }
        if ( isset( $_REQUEST[ 'query' ] ) && ( $_REQUEST[ 'query' ] ) ) {
            $queries = preg_split('/\s{1,}/', $_REQUEST[ 'query' ] );
            if ( isset( $_REQUEST[ 'query_column' ] ) && ( $_REQUEST[ 'query_column' ] ) ) {
                $query_column = $_REQUEST[ 'query_column' ];
            }
            if (! $query_column ) $query_column = 'keywords';
            if (! $_obj->has_column( $query_column ) ) {
                $query_column = 'name';
            }
            if (! $_obj->has_column( $query_column ) ) {
                $query_column = 'title';
            }
            if (! $_obj->has_column( $query_column ) ) {
                $query_column = 'label';
            }
            if (! $_obj->has_column( $query_column ) ) {
                $query_column = 'text';
            }
            if ( $_obj->has_column( $query_column ) ) {
                if ( isset( $_REQUEST[ 'query_and_or' ] ) && ( $_REQUEST[ 'query_and_or' ] ) ) {
                    $query_and_or = $_REQUEST[ 'query_and_or' ];
                    $query_and_or = strtoupper( $query_and_or );
                    if ( ( $query_and_or != 'OR' ) && ( $query_and_or != 'AND' ) ) {
                        $query_and_or = NULL;
                    }
                }
                if ( isset( $_REQUEST[ 'query_op' ] ) && ( $_REQUEST[ 'query_op' ] ) ) {
                    $query_op = $_REQUEST[ 'query_op' ];
                    $query_op = strtoupper( $query_op );
                    if ( preg_match( '/LIKE/', $query_op ) ) {
                        $is_like = 1;
                    }
                    if (! preg_match('/^=|>|<|<=|>=|LIKE|NOT\sLIKE$/', $query_op, $matchs ) ) {
                        $query_op = NULL;
                    }
                    if (! $query_op ) {
                        $query_op = 'LIKE';
                        $is_like = 1;
                    } 
                }
                if (! $query_and_or ) $query_and_or = 'OR';
                $query_and_or = strtoupper( $query_and_or );
                $likes = '';
                foreach( $queries as $search ) {
                    $search = $ctx->mt->db()->escape( $search );
                    if ( $likes ) {
                        $likes .= " ${query_and_or} ";
                    }
                    if ( $is_like ) {
                        $search = "%${search}%";
                    }
                    $likes .= " ${datasource}_${query_column} ${query_op} '${search}'";
                }
                $whereOrderBy .= " AND ( ${likes} )";
            }
        }
        if ( $datasource == 'customobject' ) {
            $whereOrderBy .= " AND customobject_class='${class}'";
        }
        if ( $and_or == 'or' ) {
            if ( $cf_where ) {
                $whereOrderBy .= " AND ( ${cf_where} )";
                $extras[ 'join' ] = array(
                    "mt_${datasource}_meta" => array(
                        'condition' => 
                        "mt_${datasource}.${datasource}_id=mt_${datasource}_meta.${datasource}_meta_${datasource}_id",
                    ),
                );
                $extras[ 'distinct' ] = 1;
            }
            $count_args = array( 'where' => $whereOrderBy );
            $count_args[ 'join' ] = $extras[ 'join' ];
            if ( $debug ) {
                echo htmlspecialchars( $whereOrderBy );
                var_dump( $extras );
                echo '<br />';
            }
            $total_result = $_obj->count( $count_args );
        } else {
            $whereOrderBy .= " AND ${datasource}_id in ( ${ids} )";
        }
        if (! $bulk_sort ) {
            if ( $sort_by && $sort_order ) {
                $whereOrderBy .= " ORDER BY ${datasource}_${sort_by} ${sort_order}";
            }
        }
        if ( $debug ) {
            echo htmlspecialchars( $whereOrderBy );
            echo '<br /><br />';
        }
        // Search Objects by Fields values
        // ${datasource}_blog_id = 1 AND ( ( ${datasource}_meta_vchar_idx = '${value}' AND customobject_meta_type='field.${field_basename}' ) )
        // or
        // ${datasource}_blog_id = 1 AND ${datasource}_id IN ( ${ids} )
        $objects = $_obj->Find( $whereOrderBy, FALSE, FALSE, $extras );
        if (! $objects ) {
            $ctx->restore( $localvars );
            $repeat = FALSE;
            return;
        }
        if ( $sorted ) {
            if ( isset( $obj_ids ) ) {
                if ( count( $obj_ids ) ) {
                    $newObjects = array();
                    $objectIds = array();
                    foreach( $objects as $obj ) {
                        $objectIds[ $obj->id ] = $obj;
                    }
                    foreach ( $obj_ids as $id ) {
                        $newObjects[] = $objectIds[ $id ];
                    }
                    $objects = $newObjects;
                }
            }
        }
        if ( ( $and_or == 'and' ) || $bulk_sort ) {
            if ( $and_or == 'and' ) {
                $total_result = count( $objects );
            }
            if ( $bulk_sort ) {
                $sort_arr = array();
                $objects_arr = array();
                $sort_by = 'field.' . $sort_by;
                foreach ( $objects as $obj ) {
                    $sort_arr[ $obj->id ] = $obj->$sort_by;
                    $objects_arr[ $obj->id ] = $obj;
                }
                if ( $bulk_sort_type == 'string' ) {
                    if ( $sort_order == 'ASC' ) {
                        asort( $sort_arr );
                    } else {
                        arsort( $sort_arr );
                    }
                } else {
                    if ( $sort_order == 'ASC' ) {
                        asort( $sort_arr, SORT_NUMERIC );
                    } else {
                        arsort( $sort_arr, SORT_NUMERIC );
                    }
                }
                $new_objects = array();
                foreach( $sort_arr as $id => $value ) {
                    $new_objects[] = $objects_arr[ $id ];
                }
                $objects = $new_objects;
            }
            if ( $limit ) {
                $objects = array_slice( $objects , $offset, $limit );
            }
        }
        $ctx->stash( 'objects', $objects );
        $ctx->stash( '_objects_counter', 0 );
        $ctx->stash( 'total_result', $total_result );
        if ( isset( $_SERVER[ 'QUERY_STRING' ] ) ) {
            $query_string = $_SERVER[ 'QUERY_STRING' ];
            parse_str( $query_string, $queries );
            if ( isset( $queries[ 'offset' ] ) ) {
                unset( $queries[ 'offset' ] );
            }
            $query_string = '';
            foreach ( $queries as $q => $v ) {
                if ( $query_string ) $query_string .= '&';
                $query_string .= "${q}=${v}";
            }
            $ctx->stash( 'query_string', $query_string );
        }
    }
    $objects = $ctx->stash( 'objects' );
    $counter = $ctx->stash( '_objects_counter' );
    $query_string = $ctx->stash( 'query_string' );
    $total_result = $ctx->stash( 'total_result' );
    if ( $counter < count( $objects ) ) {
        $object = $objects[ $counter ];
        $count = $counter + 1;
        $ctx->stash( '_objects_counter', $count );
        $ctx->stash( $datasource, $object );
        if ( $object->has_column( 'blog_id' ) ) {
            if ( $object->blog_id != $blog_id ) {
                $blog = $ctx->mt->db()->fetch_blog( $object->blog_id );
                $ctx->stash( 'blog', $blog );
                $ctx->stash( 'blog_id', $object->blog_id );
            }
        }
        $ctx->__stash[ 'vars' ][ '__query_string__' ] = $query_string;
        if ( $limit && isset( $offset ) ) {
            $ctx->__stash[ 'vars' ][ '__next_offset__' ] = $offset + $limit;
        } else {
            $ctx->__stash[ 'vars' ][ '__next_offset__' ] = '0';
        }
        $ctx->__stash[ 'vars' ][ '__total__' ]   = $total_result;
        $ctx->__stash[ 'vars' ][ '__counter__' ] = $count;
        $ctx->__stash[ 'vars' ][ '__odd__' ]     = ( $count % 2 ) == 1;
        $ctx->__stash[ 'vars' ][ '__even__' ]    = ( $count % 2 ) == 0;
        $ctx->__stash[ 'vars' ][ '__first__' ]   = $count == 1;
        $ctx->__stash[ 'vars' ][ '__last__' ]    = ( $count == count( $objects ) );
        $repeat = TRUE;
    } else {
        $ctx->restore( $localvars );
        $repeat = FALSE;
    }
    return $content;
}
?>